"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RabbitmqMessagingConsumer = void 0;
const amqp_channel_1 = require("../channel/amqp.channel");
const const_1 = require("../const");
const messaging_1 = require("@nestjstools/messaging");
const common_1 = require("@nestjs/common");
const messaging_2 = require("@nestjstools/messaging");
const rabbitmq_migrator_1 = require("../migrator/rabbitmq.migrator");
const buffer_1 = require("buffer");
let RabbitmqMessagingConsumer = class RabbitmqMessagingConsumer {
    constructor(rabbitMqMigrator) {
        this.rabbitMqMigrator = rabbitMqMigrator;
        this.channel = undefined;
    }
    async consume(dispatcher, channel) {
        await this.rabbitMqMigrator.run(channel);
        this.channel = channel;
        channel.connection.createConsumer({
            queue: channel.config.queue,
            queueOptions: { durable: true },
        }, async (msg) => {
            const rabbitMqMessage = msg;
            let message = rabbitMqMessage.body;
            if (buffer_1.Buffer.isBuffer(message)) {
                const messageContent = message.toString();
                message = JSON.parse(messageContent);
            }
            const routingKey = rabbitMqMessage.headers?.[const_1.RABBITMQ_HEADER_ROUTING_KEY] ?? rabbitMqMessage.routingKey;
            dispatcher.dispatch(new messaging_1.ConsumerMessage(message, routingKey));
        });
        return Promise.resolve();
    }
    onError(errored, channel) {
        if (channel.config.deadLetterQueueFeature) {
            const publisher = channel.connection.createPublisher();
            const envelope = {
                headers: { 'messaging-routing-key': errored.dispatchedConsumerMessage.routingKey },
                exchange: 'dead_letter.exchange',
                routingKey: `${channel.config.queue}_dead_letter`
            };
            publisher.send(envelope, errored.dispatchedConsumerMessage.message);
        }
        return Promise.resolve();
    }
    async onApplicationShutdown(signal) {
        if (this.channel) {
            await this.channel.connection.close();
        }
    }
};
exports.RabbitmqMessagingConsumer = RabbitmqMessagingConsumer;
exports.RabbitmqMessagingConsumer = RabbitmqMessagingConsumer = __decorate([
    (0, common_1.Injectable)(),
    (0, messaging_2.MessageConsumer)(amqp_channel_1.AmqpChannel),
    __metadata("design:paramtypes", [rabbitmq_migrator_1.RabbitmqMigrator])
], RabbitmqMessagingConsumer);
//# sourceMappingURL=rabbitmq-messaging.consumer.js.map